import Module from '../Module.ts'
import Kernel from '../Kernel.ts'
import {Request} from '../../Request.ts'

/**
 * HTTP kernel module to call the request's prepare method.
 * @extends Module
 */
export default class PrepareRequest extends Module {

    public static register(kernel: Kernel) {
        kernel.register(this).first()
    }

    /**
     * Prepare the request for Daton processing.
     * @param {Request} request
     */
    public async apply(request: Request): Promise<Request> {
        await request.prepare()
        return request
    }

}
